.586
.MODEL FLAT, STDCALL
OPTION CASEMAP:NONE

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\masm32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\masm32.lib

MAXV EQU 0FFFFFFFFh

PrimeData STRUCT
	value DWORD ?
	next  DWORD ?
PrimeData ENDS

outf MACRO v1:REQ, v2:REQ, v3:REQ
	pushad
	invoke wsprintf, pBufCur, addr szCom, v1, v2, v3
	invoke lstrlen, pBufCur
	add pBufCur, eax
	popad
ENDM

begtim MACRO
	rdtsc
	mov stim[4], edx
	mov stim[0], eax
ENDM

endtim MACRO
	rdtsc
	mov etim[4], edx
	mov etim[0], eax

	fild qword ptr etim
	fild qword ptr stim
	fsubp st(1), st(0)
	fistp ttim

	mov eax, ttim
ENDM

LinDiv PROTO
PrimDiv PROTO
GenPrime PROTO ; generates j primes

.data
align 16
j         dd 6000

szCom     db "%d,%d,%d", 0Dh, 0Ah, 0

szFile    db "c:\tim.csv", 0

.data?
align 16
a         dd 1024 dup (?)
b         dd 1024 dup (?)
n         dd ?
s         dd ?
i         dd ?
stim      dd ?, ?
etim      dd ?, ?
ttim      dd ?
pPrimes   dd ?
dwTemp    dd ?
dw1       dd ?
dw2       dd ?
hFile     dd ?
dwUseless dd ?
pBuff     dd ?
pBufCur   dd ?

.code
start:
	pushad
	
	call GenPrime
	
	invoke CreateFile, addr szFile, GENERIC_WRITE, NULL, NULL, CREATE_ALWAYS, NULL, NULL
	mov hFile, eax

	invoke GlobalAlloc, GMEM_FIXED, 200000
	mov pBuff, eax
	mov pBufCur, eax
	
	invoke GetCurrentThreadId
	invoke SetThreadPriority, eax, THREAD_PRIORITY_TIME_CRITICAL

	mov dwTemp, 2
big_loop:
	push dwTemp
	pop n

	call PrimDiv
	mov dw1, eax
	call LinDiv
	mov dw2, eax
	
	call PrimDiv
	cmp eax, dw1
	jae @F
	mov dw1, eax
@@:
	call LinDiv
	cmp eax, dw2
	jae @F
	mov dw2, eax
@@:
	call PrimDiv
	cmp eax, dw1
	jae @F
	mov dw1, eax
@@:
	call LinDiv
	cmp eax, dw2
	jae @F
	mov dw2, eax
@@:
	call PrimDiv
	cmp eax, dw1
	jae @F
	mov dw1, eax
@@:
	call LinDiv
	cmp eax, dw2
	jae @F
	mov dw2, eax
@@:

	outf dwTemp, dw1, dw2
	
	add dwTemp, 65637
	mov eax, dwTemp
	cmp eax, 400000000
	jna big_loop
	
	invoke GetCurrentThreadId
	invoke SetThreadPriority, eax, THREAD_PRIORITY_NORMAL

	invoke lstrlen, pBuff
	invoke WriteFile, hFile, pBuff, eax, addr dwUseless, NULL
	
	invoke GlobalFree, pBuff
	invoke GlobalFree, pPrimes
	invoke CloseHandle, hFile
	
	popad

	invoke ExitProcess, 0

GenPrime PROC
	mov ecx, j
	shl ecx, 3
	invoke GlobalAlloc, GMEM_FIXED, ecx
	mov pPrimes, eax

	mov eax, pPrimes

	mov [eax][PrimeData.value], 2
	mov [eax][PrimeData.next], 4

	mov ecx, 3
	mov edi, 1

outer_loop:

	mov esi, pPrimes
	xor edx, edx

inner_loop:

	mov eax, ecx
	add eax, [esi]
	jnc skip_1

	mov dword ptr [esi+4], MAXV
	cmp ecx, [esi+4]
	jmp skip_3

skip_1:
	mov eax, [esi]

skip_1_loop:

	cmp ecx, [esi+4]
	jbe skip_3

	add [esi+4], eax

	jmp skip_1_loop

skip_3:
	je  inner_loop_end

	add esi, 8
	add edx, 1
	cmp edx, edi
	jne inner_loop

	mov [esi], ecx
	mov eax, ecx
	shl eax, 1
	mov [esi+4], eax
	add edi, 1

inner_loop_end:
	add ecx, 1
	cmp ecx, MAXV
	je  outer_loop_end
	cmp edi, j
	je  outer_loop_end
	jmp outer_loop

outer_loop_end:
	
	ret
GenPrime ENDP

LinDiv PROC
	fild  n
	fsqrt
	fistp s

	begtim

	mov ecx, 1
	mov edi, offset a
	mov esi, offset b
	xor ebx, ebx
main_loop:
	mov eax, dword ptr n
	xor edx, edx
	div ecx
	or  edx, edx
	jnz @F
	mov [edi], ecx
	mov [esi], eax
	add esi, 4
	add edi, 4
	add ebx, 1
@@:
	add ecx, 1
	cmp ecx, s
	jbe main_loop
	mov j, ebx

	endtim
	
	ret
LinDiv ENDP

PrimDiv PROC
	fild n
	fsqrt
	fistp s

	begtim

	mov eax, n
	mov ebx, eax
	mov esi, pPrimes
	xor edi, edi
	mov ecx, s

	mov [esi][PrimeData.next], edi
	
PrimDiv_Loop:	
	cmp ecx, [esi][PrimeData.value]
	jna PrimDiv_EndLoop
	
	xor edx, edx
	div dword ptr [esi][PrimeData.value]
	or  edx, edx
	jnz PrimDiv_NoDiv
	
	mov ebx, eax
	add [esi][PrimeData.next], 1
	cmp eax, 1
	je  PrimDiv_EndLoop
	jmp PrimDiv_Loop
	
PrimDiv_NoDiv:
	add esi, 8
	mov [esi][PrimeData.next], edi
	mov eax, ebx
	jmp PrimDiv_Loop

PrimDiv_EndLoop:

	endtim

	ret
PrimDiv ENDP

end start 
