.586
.MODEL FLAT, STDCALL
OPTION CASEMAP:NONE

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\masm32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\masm32.lib

MAXV EQU 0FFFFFFFFh
DISPPRIMES EQU 1

PrimeData STRUCT
	value DWORD ?
	next  DWORD ?
PrimeData ENDS

outtab MACRO v1:REQ, v2:REQ
	pushad
	invoke dwtoa, v1, addr szBuffer
	invoke StdOut, addr szBuffer
	invoke StdOut, addr szTab
	popad
	pushad
	invoke dwtoa, v2, addr szBuffer
	invoke StdOut, addr szBuffer
	invoke StdOut, addr szRet
	popad
ENDM

PrimDiv PROTO
GenPrime PROTO ; generates j primes

.data
align 16

n         dd 2147483646
s         dd 0
f1p2      dd 1.2f
i         dd 1
j         dd 1000
szRet     db 0Dh, 0Ah, 0
szTab     db 09h, 0

.data?
align 16
a         dd 1024 dup (?)
szBuffer  db 48 dup (?)
pPrimes   dd ?

.code
start:
	pushad
	
	call PrimDiv
	
	; delete the array
	
	invoke GlobalFree, pPrimes
	
	popad

	invoke ExitProcess, 0

GenPrime PROC
	mov ecx, j
	shl ecx, 3
	invoke GlobalAlloc, GMEM_FIXED, ecx
	mov pPrimes, eax

	mov eax, pPrimes

	mov [eax][PrimeData.value], 2
	mov [eax][PrimeData.next], 4

	mov ecx, 3
	mov edi, 1

outer_loop:

	mov esi, pPrimes
	xor edx, edx

inner_loop:

	mov eax, ecx
	add eax, [esi]
	jnc skip_1

	mov dword ptr [esi+4], MAXV
	cmp ecx, [esi+4]
	jmp skip_3

skip_1:
	mov eax, [esi]

skip_1_loop:

	cmp ecx, [esi+4]
	jbe skip_3

	add [esi+4], eax

	jmp skip_1_loop

skip_3:
	je  inner_loop_end

	add esi, 8
	add edx, 1
	cmp edx, edi
	jne inner_loop

	mov [esi], ecx
	mov eax, ecx
	shl eax, 1
	mov [esi+4], eax
	add edi, 1

inner_loop_end:
	add ecx, 1
	cmp ecx, MAXV
	je  outer_loop_end
	cmp edi, j
	je  outer_loop_end
	jmp outer_loop

outer_loop_end:
	
	ret
GenPrime ENDP

PrimDiv PROC
	fild n                   ; st(0) = n
	fsqrt                    ; st(0) = s
	fist s
	fld1                     ; st(0) = 1, st(1) = s
	fld st(1)                ; st(0) = s, st(1) = 1, st(2) = s
	fyl2x                    ; st(0) = log2(s), st(1) = s
	fldl2e                   ; st(0) = log2(e), st(1) = log2(s), st(2) = s
	fdivp st(1), st(0)       ; st(0) = ln(s), st(1) = s
	fdivp st(1), st(0)       ; st(0) = s/ln(s)
	fmul f1p2                ; st(0) = 1.2*s/ln(s)
	fistp j
	
	; Check for algo's sensible uper limit & generate primes
	
	mov eax, j
	cmp eax, 20000
	jna @F
	ret
@@:
	call GenPrime

	; Begin the prime factorisation (unoptimised)

	mov eax, n
	mov ebx, eax
	mov esi, pPrimes
	xor edi, edi
	mov ecx, s

	mov [esi][PrimeData.next], edi
	
PrimDiv_Loop:	
	cmp ecx, [esi][PrimeData.value]
	jna PrimDiv_EndLoop
	
	xor edx, edx
	div dword ptr [esi][PrimeData.value]
	or  edx, edx
	jnz PrimDiv_NoDiv
	
	mov ebx, eax
	add [esi][PrimeData.next], 1
	cmp eax, 1
	je  PrimDiv_EndLoop
	jmp PrimDiv_Loop
	
PrimDiv_NoDiv:
IFDEF DISPPRIMES
	test dword ptr [esi][PrimeData.next], 0FFFFFFFFh
	jz @F
	outtab [esi][PrimeData.value], [esi][PrimeData.next]
@@:
ENDIF
	add esi, 8
	mov [esi][PrimeData.next], edi
	mov eax, ebx
	jmp PrimDiv_Loop

PrimDiv_EndLoop:

IFDEF DISPPRIMES
	test dword ptr [esi][PrimeData.next], 0FFFFFFFFh
	jz @F
	outtab [esi][PrimeData.value], [esi][PrimeData.next]
@@:
	cmp eax, 1
	je @F
	outtab eax, 1
@@:
ENDIF

	ret
PrimDiv ENDP

end start 
